> ## Documentation Index
> Fetch the complete documentation index at: https://docs.maia.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create environment overrides

> Create environment-level overrides for a given project variable



## OpenAPI

````yaml /openapi/public-api-endpoint-reference.yaml post /v1/projects/{projectId}/variables/{variableName}/environment-overrides
openapi: 3.1.0
info:
  title: Maia Public REST API
  version: '1.0'
servers:
  - description: EU1
    url: https://eu1.api.matillion.com/dpc
  - description: US1
    url: https://us1.api.matillion.com/dpc
security:
  - bearerAuth: []
tags:
  - description: Manage Schedules
    name: Schedules
  - description: Manage Connections
    name: Connections
  - description: Operations for managing Project Variables
    name: Project Variables
  - description: Manage Pipelines
    name: Pipelines
  - description: Review pipelines against quality rules
    name: Pipeline Quality Review
  - description: Execute tests within a project
    name: Test Execution
  - description: Manage your AI agent tasks
    name: AI Agent Tasks
  - description: SCIM endpoints for user/group permission management
    name: Directory Integration
  - description: Publish shared pipeline artifacts
    name: Shared Pipeline Artifacts
  - description: Manage Repositories
    name: Repositories
  - description: Report on Credit Consumption
    name: Consumption
  - description: Manage Artifacts
    name: Artifacts
  - description: Operations for data lineage and governance
    name: Data Lineage
  - description: Manage Streaming Pipelines
    name: Streaming Pipelines
  - description: Execute a pipeline
    name: Pipeline Execution
  - description: ''
    name: Environments
  - description: ''
    name: Projects
  - description: Manage Agents
    name: Agents
  - description: Operations for managing Environment-level Overrides of Project Variables
    name: Project Variable Environment Overrides
  - description: Query audit events
    name: Audit Events
  - description: Connector Profiles
    name: Connectors
paths:
  /v1/projects/{projectId}/variables/{variableName}/environment-overrides:
    post:
      tags:
        - Project Variable Environment Overrides
      summary: Create environment overrides
      description: Create environment-level overrides for a given project variable
      operationId: createProjectVariableEnvironmentOverrides
      parameters:
        - in: path
          name: projectId
          required: true
          schema:
            type: string
            format: uuid
        - in: path
          name: variableName
          required: true
          schema:
            type: string
            maxLength: 255
            minLength: 0
            pattern: ^(?!\$$)[a-zA-Z_$][a-zA-Z0-9_$]*$
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/CreateProjectVariableEnvironmentOverridesRequest
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CreateProjectVariableEnvironmentOverridesResponse
          description: >-
            Project variable environment overrides created or updated. Returns
            both successful and failed overrides.
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Wrong request parameters used
        '401':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Unauthorized
        '403':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Forbidden
        '404':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Project or variable not found
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Unexpected error occurred
        '504':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Gateway timeout
components:
  schemas:
    CreateProjectVariableEnvironmentOverridesRequest:
      type: object
      properties:
        overrides:
          type: array
          items:
            $ref: '#/components/schemas/EnvironmentOverrideRequest'
          minItems: 1
      required:
        - overrides
    CreateProjectVariableEnvironmentOverridesResponse:
      type: object
      properties:
        failedOverrides:
          type: array
          items:
            $ref: '#/components/schemas/FailedOverride'
        successfulOverrides:
          type: array
          items:
            $ref: '#/components/schemas/EnvironmentOverride'
        type:
          type: string
          enum:
            - NUMBER
            - TEXT
            - DATETIME
        variableName:
          type: string
    ProblemDetail:
      type: object
      properties:
        detail:
          type: string
        instance:
          type: string
        status:
          type: integer
          format: int32
        title:
          type: string
        type:
          type: string
          format: uri
        violations:
          type: array
          items:
            type: string
    EnvironmentOverrideRequest:
      type: object
      properties:
        environmentName:
          type: string
        value:
          $ref: '#/components/schemas/JsonNode'
    FailedOverride:
      type: object
      properties:
        environmentName:
          type: string
        reason:
          type: string
    EnvironmentOverride:
      type: object
      properties:
        environmentName:
          type: string
        value:
          $ref: '#/components/schemas/JsonNode'
    JsonNode: {}
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: a valid bearer token
      scheme: bearer
      type: http

````